#include <windows.h>
#include <tchar.h>
#include <vector>
#include "list.hpp"

typedef TCHAR* TCHARP;

using namespace std;


vector<TCHARP> file_vec;

//	t@C̏ۑ\

struct FILE_LINK{
	friend struct FILE_LIST;
	TCHAR* name;			//	t@C
	FILE_LINK* next;	//	̃t@Cւ̃|C^
	FILE_LIST* child;	//	`ChtH_[
	FILE_LINK(){
		name = 0;
		next = 0;
		child = 0;
	}
};

//	t@CǗ\

struct FILE_LIST : public LIST{
	TCHAR* name;	//	etH_[
	FILE_LIST* parent;	//	etH_[FILE_LIST
	FILE_LIST() : LIST() {
		name = 0;
		parent = 0;
	}
	void append(FILE_LINK* p){	//	t@Cǉ
		LIST::append((void*)p);
	}
	FILE_LINK* next(void){	//	̃t@C	
		return (FILE_LINK*)LIST::next();
	}
	FILE_LINK* first(void){	//	ŏ̃t@C
		return (FILE_LINK*)LIST::first();
	}
	int find(TCHAR* pass, int sz, TCHAR* card);	// passŎtH_[cardŎ郏CJ[hɍvt@CFILE_LISTɓo^
	FILE_LINK* dupchk(TCHAR* fullpass);	// fullpassFILE_LISTɓo^Ă邩
	void short_puts(TCHAR* pass, int num);	// t@C̈ꗗWo͂ɏo͂BtH_[KwƂɃCfgB
	void full_vec(TCHAR* pass, int sz,vector<TCHARP>& vec); // tH_[Et@CSp甼pɕϊ
	FILE_LINK* find_name(TCHAR* name){	//	`ChtH_[܂܂v閼OFILE_LINK*ԂB
		FILE_LINK* p = first();
		while (p){
			if (_tcscmp(name, p->name) == 0){
				return p;
			}
			p = next();
		}
		return 0;
	}
	void clear(void){	//	FILE_LISTɓo^ĂtH_[Et@CNAB
		FILE_LINK* p = first();
		FILE_LINK* np;
		while (p){
			np = next();
			if (p->child){
				p->child->clear();
			}
			delete p->name;
			delete p;
			p = np;
		}
	}
};

//	΃pXo^Ă邩mFAo^ĂFILE_LINK*ԂBo^ĂȂ0ԂB

FILE_LINK* FILE_LIST::dupchk(TCHAR* fullpass){
	FILE_LIST* flp = this;
	FILE_LINK* p;
	TCHAR* sp = fullpass;
	TCHAR* tp = fullpass;
	FILE_LINK* np;
	while (*sp){
		if (*sp == _T('\\')){
			sp[0] = _T('\0');
			p = flp->first();
			np = 0;
			while (p){
				if (_tcscmp(tp, p->name) == 0){
					np = p;
					flp = p->child;
					break;
				}
				p = flp->next();
			}
			if (np == 0)
				return 0;
			tp = sp + 1;
		}
		++sp;
	}

	p = flp->first();
	while (p){
		if (_tcscmp(tp, p->name) == 0){
			return p;
		}
		p = flp->next();
	}
	return 0;
}


void FILE_LIST::short_puts(TCHAR* pass, int num){
	FILE_LINK* p = first();
	while (p){
		for (int i = 0; i<num; i++)
			_tprintf(_TEXT("\t"));
		if (p->child){
			_tprintf(_TEXT("[%s]\n"), p->name);
			p->child->short_puts(pass, num + 1);
		}
		else
			_tprintf(_TEXT("%s\n"), p->name);
		p = next();
	}

}
#if 1
void FILE_LIST::full_vec(TCHAR* pass, int sz,vector<TCHARP>& vec){
	TCHAR dtc_file[MAX_PATH * 8];
	TCHAR* pass_end = pass + _tcslen(pass);
	TCHAR* dtc_end = dtc_file + (pass_end - pass);
	pass_end[0] = _T('\\');
	_tcscpy_s(dtc_file, sizeof(dtc_file)/sizeof(TCHAR), pass);
	dtc_end[0] = _T('\\');

	FILE_LINK* p = first();
	while (p){
		_tcscpy_s(pass_end + 1, sz - (pass_end - pass + 1), p->name);
		_tcscpy_s(dtc_end + 1, sz - (pass_end - pass + 1), p->name);
		if (p->child){
			p->child->full_vec(pass, int(sz - (pass_end - pass + 1)),vec);

		}else{
			vec.push_back(_tcsdup(pass));

		}
		p = next();
	}
	pass_end[0] = _T('\0');
}
#endif
//	ċAĂяoɂTufBNg̎wt@C

int FILE_LIST::find(TCHAR* pass, int sz, TCHAR* card){
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	FILE_LIST* child;
	int num = 0;	//	t@C

	TCHAR* pass_end = pass + _tcslen(pass);	//	pX̍Ō̈ʒu
	TCHAR* pass_add;	//	pX̍Ō̈ʒu(\܂)

	if (*(pass_end - 1) == _T(':')){	//	hCûݎw肳ꂽꍇ
		pass_add = pass_end;
	}
	else{	//	tH_[܂܂Ăꍇ
		pass_add = pass_end + 1;
		pass_end[0] = _T('\\');
	}
	_tcscpy_s(pass_add, sz - (pass_add - pass + 1), _TEXT("*.*"));	//	TufBNǧ

	hFind = FindFirstFile(pass, &FindFileData);
	if (hFind != INVALID_HANDLE_VALUE){
		do{
			if ((FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
			if (_tcscmp(FindFileData.cFileName, _TEXT("..")) != 0 && _tcscmp(FindFileData.cFileName, _TEXT(".")) != 0){	//	efBNgyь݂̃fBNg͖
				_tcscpy_s(pass_add, sz - (pass_add - pass + 1), FindFileData.cFileName);
				size_t len = _tcslen(FindFileData.cFileName);
				FILE_LINK* tp = find_name(FindFileData.cFileName);
				if (tp == 0){	//	tH_o^ĂȂꍇ
					TCHAR* n = new TCHAR[len + 1];
					_tcscpy_s(n, len + 1, FindFileData.cFileName);
					FILE_LINK* p = new FILE_LINK;
					p->name = n;
					p->next = 0;
					append(p);
					p->child = new FILE_LIST;
					child = p->child;
					child->parent = this;	//	etH_[o^
				}
				else{	//	tH_łɓo^Ăꍇ
					child = tp->child;
				}
				num += child->find(pass, int(sz - (pass_add - pass + 1)), card);	//	TufBNg̒
			}
		} while (FindNextFile(hFind, &FindFileData));
	}
	FindClose(hFind);

	_tcscpy_s(pass_add, sz - (pass_add - pass + 1), card);
	hFind = FindFirstFile(pass, &FindFileData);
	if (hFind != INVALID_HANDLE_VALUE){
		do{
			if (!(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
				FILE_LINK* tp = find_name(FindFileData.cFileName);
				if (tp == 0){	//t@Co^ĂȂ̂œo^
					++num;
					size_t len = _tcslen(FindFileData.cFileName);
					TCHAR* n = new TCHAR[len + 1];
					_tcscpy_s(n, len + 1, FindFileData.cFileName);
					FILE_LINK* p = new FILE_LINK;
					p->name = n;
					p->next = 0;
					p->child = 0;
					append(p);
				}
			}
		} while (FindNextFile(hFind, &FindFileData));
		pass_end[0] = _T('\0');
		FindClose(hFind);
		return num;
	}
	else{
		pass_end[0] = _T('\0');
		FindClose(hFind);
		return num;
	}
}
